=== debian/changelog ===
shiboken (1.2.1-3build1) trusty; urgency=medium

  * No-change rebuild to drop Python 3.3 support.

 -- Matthias Klose <doko@ubuntu.com>  Sun, 23 Mar 2014 15:28:08 +0000

shiboken (1.2.1-3) unstable; urgency=low

  [ Dmitry Shachnev ]
  * Drop refcounting extension, removed in Sphinx 1.2 (Closes: #735835)

  [ Didier Raboud ]
  * Blacklist some tests in the testsuite for the debug flavour of Python3.4
  * Re-order debian/copyright for CF-1.0 conformance
  * Bump Standards-Version to 3.9.5 without changes needed

 -- Didier Raboud <odyx@debian.org>  Thu, 27 Feb 2014 18:23:00 +0100

shiboken (1.2.1-2) unstable; urgency=low

  * Rewrite debian/copyright with CF-1.0 (Closes: #722504)
  * Correct the default python suffix for python3, make sure cmake's
    default is python2's

 -- Didier Raboud <odyx@debian.org>  Wed, 18 Sep 2013 20:07:19 +0200

shiboken (1.2.1-1) unstable; urgency=low

  * New 1.2.1 upstream release.

  [ Bart Martens ]
  * Update debian/watch

  [ Didier Raboud ]
  * Bump libshiboken SOVERSION to 1.2, update symbols
    - Add four new 1.2.1 symbols
  * Drop upstream-imported patches, refresh the other
  * Add patch to fix one test's exceptions' Python3 syntax
  * Drop the explicit dependencies of Libs and Cflags in pkg-config in
    favour of a Requires (LP: #1155595)
  * Drop obsolete source lintian override for dh 9
  * Replaced Nokia with Digia in debian/copyright
  * Delete static-override-fix.patch as it was fixed differently by
    upstream

 -- Didier Raboud <odyx@debian.org>  Tue, 10 Sep 2013 10:36:46 +0200
